optic-distribution-system2/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index');

Auth::routes();
//Route User
Route::get('/User/datatable', 'UserController@datatable')->middleware('auth');

//Route Category
Route::get('/Category/datatable', 'CategoryController@datatable')->middleware('auth');
Route::patch('/Category/json', 'CategoryController@getItemJson')->middleware('auth');
Route::get('/Category/jsonSelect', 'CategoryController@getItemJsonSelect2')->middleware('auth');

//Route SubCategory
Route::get('/SubCategory/datatable/{id}', 'SubCategoryController@datatable')->middleware('auth');
Route::patch('/SubCategory/json', 'SubCategoryController@getItemJson')->middleware('auth');
Route::get('/SubCategory/jsonSelect', 'SubCategoryController@getItemJsonSelect2')->middleware('auth');

//Route Optic
Route::get('/Optic/datatable', 'OpticController@datatable')->middleware('auth');
Route::patch('/Optic/json', 'OpticController@getOpticJson')->middleware('auth');

//Route Item
Route::get('/Item/datatable', 'ItemController@datatable')->middleware('auth');
Route::patch('/Item/json', 'ItemController@getItemJson')->middleware('auth');
Route::patch('/Item/jsonitemWithStock', 'ItemController@getItemWithStockJson')->middleware('auth');
Route::get('/Item/jsonSelect', 'ItemController@getItemJsonSelect2')->middleware('auth');

//Route Order
Route::get('/Order/datatable', 'SalesController@datatable')->middleware('auth');
Route::get('/Order/view/{id}', 'SalesController@view')->middleware('auth');
Route::get('/Order/edit/{id}', 'SalesController@edit')->middleware('auth');
Route::get('/Order/retur/{id}', 'SalesController@retur')->middleware('auth');
Route::post('/Order/retur/{id}', 'SalesController@prosesRetur')->middleware('auth');

Route::post('/Order/editSales/{id}', 'SalesController@updateSales')->middleware('auth');


Route::get('/Category/SubCategory/{id}', 'CategoryController@ajax_subcategory')->middleware('auth');
Route::get('/ItemStock/datatable', 'ItemStockController@datatable')->middleware('auth');
Route::get('/Print/{id}', 'PrintController@index')->middleware('auth');
Route::get('/Print/{id}/{id_payment}', 'PrintController@payment')->middleware('auth');
Route::get('/Print/ReturDistributor/{id}', 'PrintController@ReturDistributor')->middleware('auth');


Route::resource('User', 'UserController')->middleware('auth');
Route::resource('Category', 'CategoryController')->middleware('auth');
Route::resource('SubCategory', 'SubCategoryController')->middleware('auth');
Route::resource('Optic', 'OpticController')->middleware('auth');
Route::resource('Item', 'ItemController')->middleware('auth');
//Route::resource('Payment', 'PaymentController')->middleware('auth');
Route::get('Payment/{id}', ["as" => "Payment.index", "uses" => "PaymentController@index"])->middleware('auth');
Route::get('Payment/{id}/datatable', 'PaymentController@datatable')->middleware('auth');
Route::get('Payment/{id}/create', 'PaymentController@create')->middleware('auth');
Route::post('Payment', 'PaymentController@store')->middleware('auth');

Route::resource('Stock', 'ItemStockController')->middleware('auth');
Route::resource('Order', 'SalesController')->middleware('auth');

Route::get('/home', 'HomeController@index')->name('home')->middleware('auth');


Route::get('/Item/test', 'ItemController@test')->middleware('auth');

Route::get('/Stock/updateItemStock/{id}', 'ItemStockController@newStock')->middleware('auth');
Route::get('/Stock/detail/{id}', 'ItemStockController@detailStock')->middleware('auth');
Route::get('/receiveItemStock', 'ItemStockController@receiveStock')->middleware('auth');
Route::get('/Stock/create', 'ItemStockController@receiveStock')->middleware('auth');


Route::get('/Stock/newItemStock/{id}', 'ItemStockController@newStock')->middleware('auth');
Route::get('/receiveItemStock', 'ItemStockController@receiveStock')->middleware('auth');

// report controller
Route::get('/Report/inventoryDatatable', 'ReportController@inventoryDatatable')->middleware('auth');
Route::get('/Report/inventoryLowDatatable', 'ReportController@inventoryLowDatatable')->middleware('auth');
Route::get('/Report/expiryDatatable', 'ReportController@expiryDatatable')->middleware('auth');
Route::get('/Report/salesDatatable', 'ReportController@salesDatatable');
Route::post('/Report/salesDatatable', 'ReportController@salesDatatable');
Route::get('/Report/stokChartJson', 'ReportController@inventoryChartJSON');
Route::get('/Report/salesChartByItemJSON', 'ReportController@salesChartByItemJSON');
Route::get('/Report/salesChartByRevenueJSON', 'ReportController@salesChartByRevenueJSON');
Route::get('/Report/summaryJson', 'ReportController@summaryJson');


Route::get('/Report/inventory', 'ReportController@inventory')->middleware('auth');
Route::get('/Report/inventoryLow', 'ReportController@inventoryLow')->middleware('auth');
Route::get('/Report/sales', 'ReportController@sales')->middleware('auth');
Route::get('/Report/expiry', 'ReportController@expiry')->middleware('auth');

Route::get('/Retur', 'ReturController@index')->middleware('auth');
Route::get('/Retur/Client', 'ReturController@indexClient')->middleware('auth');
Route::get('/Retur/Client/datatable', 'ReturController@datatableClient')->middleware('auth');
Route::get('/Retur/Client/{id}', 'ReturController@viewClient')->middleware('auth');
Route::delete('/Retur/Client/delete/{id}', 'ReturController@destroyClient')->middleware('auth');

Route::get('/Retur/datatable', 'ReturController@datatable')->middleware('auth');
Route::get('/ReturDistributor/create', 'ReturController@createDistributor')->middleware('auth');
Route::post('/ReturDistributor/create', 'ReturController@storeDistributor')->middleware('auth');
Route::get('/ReturDistributor/view/{id}', 'ReturController@viewDistributor')->middleware('auth');
Route::get('/ReturDistributor/edit/{id}', 'ReturController@editDistributor')->middleware('auth');
Route::post('/ReturDistributor/edit/{id}', 'ReturController@updateDistributor')->middleware('auth');
Route::delete('/ReturDistributor/delete/{id}', 'ReturController@destroyDistributor')->middleware('auth');

Route::get('/Report/receivings', 'ReportController@receivings')->middleware('auth');



Route::get('/OpticList/datatable', 'BillingController@datatable')->middleware('auth');
Route::resource('Billing', 'BillingController')->middleware('auth');
Route::patch('/billing/json', 'BillingController@getOpticJson')->middleware('auth');

optic-distribution-system2/app/Optic.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Optic extends Model
{
    protected $primaryKey = 'id';
    protected $table = 'optics';

    public function sale(){
        return $this->hasMany('App\Sale');
      }
    public function getKotaAttribute(){
      return $this->cabang_id == 1 ? 'Kudus' : 'Semarang';
    }
}

optic-distribution-system2/app/Sale.php
<?php

namespace App;


use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
class Sale extends Model
{
use SoftDeletes;
  public function optic(){
      return $this->belongsTo('App\Optic','optic_id','id');
    }

    public function items()
    {
        return $this->belongsToMany('App\Item', 'sales_items',
          'sale_id', 'item_id')->withPivot('jumlah', 'harga_jual','diskon');
    }

    public function getStaffNameAttribute(){
      $user = User::find($this->user_id)->first();

      return $user;
    }

    public function getTotalTerbayarAttribute(){
      $retVal = Payment::where('sale_id','=',$this->id)->sum('jumlah');
      return $retVal;
    }

    public function getIdStringAttribute()
    {
        $temp = "".$this->id;
        $retVal = "";
        for($i=0;$i<(12 - strlen($temp));$i++){
          $retVal = $retVal."0";
        }
        $retVal = $retVal."". $temp;

        return $retVal;
    }

    public function getJenisStringAttribute()
    {
        if($this->jenis_pembayaran == "1"){
          return "Sekali Bayar";
        }else {
          return "Bertahap";
        }
    }

    public function getStatusPembayaranAttribute(){
      $terbayar = $this->getTotalTerbayarAttribute();

      if($terbayar!=$this->total)
        return "Pending";
      else
        return "Lunas";
    }

    protected $dates = ['deleted_at'];
}

optic-distribution-system2/resources/views/sales/index.blade.php
@extends('layouts.app')

@component('components.toastrNotif')
@endcomponent

@component('components.datatablePlugin')
@endcomponent

@section('content')

<div class="page-content-wrapper">

    <div class="page-content">
        <h2 class="page-title"> List Order
            <small>detail & manage order</small>
        </h2>

        <!-- BODY CONTENT -->
        <div class="row">
            <div class="col-md-12">
              <?php if(session('errMessage')) {?>
                  <div class="alert alert-danger">
                    {{session('errMessage')}}
                  </div>
              <?php } ?>


              <div class="portlet light ">
                  <div class="portlet-title">
                      <a href="{{url('/Order/create')}}" type="button" class="btn blue btn-outline">New Data Order</a>
                       <a href="{{url('/Billing/create')}}" target="_blank" type="button" class="btn red btn-outline pull-right">Billing</a>
                  </div>
                  <div class="portlet-body">
                    @component('components.npmDatatable')
                      @slot('idTable')
                        sales
                      @endslot
                      <thead>
                      <tr>
                        <th>
                          Tanggal
                        </th>
                        <th>
                          Invoice ID
                        </th>
                        <th>
                          Optic
                        </th>
                        <th>
                          Total
                        </th>
                        <th>
                          Jenis Pembayaran
                        </th>
                        <th>
                          Status Pembayaran
                        </th>
                        <th>
                          Action
                        </th>
                      </tr>
                      </thead>
                    @endcomponent
                  </div>
                </div>
            </div>

        </div>
        <!-- END BODY CONTENT -->

    </div>
    <!-- END CONTENT -->
</div>

@endsection

@push('scripts')
<script>

$(function() {
    @if(session('successMsg'))
      toastr.success("{{session('successMsg')}}", "Success")
    @endif

    var table = $('#sales').DataTable({
        processing: true,
        serverSide: true,
        order: [[ 1, "desc" ]],
        ajax: '{{ url("Order") }}/datatable',
        columns: [
            { data: 'created_at', name: 'created_at' },
            { data: 'id', name: 'id' },
            { data: 'optic_name', name: 'optic_name' },
            { data: 'total', name: 'total' },
            { data: 'jenis_pembayaran', name: 'jenis_pembayaran' },
            { data: 'status_pembayaran', name: 'status_pembayaran' },
            { data: 'action', name: 'action',Sortable: "false"}
        ],
        columnDefs: [
          { className: "dt-body-center", "targets": [ 2,3] },
          { width: "70px", targets: [2] },
          { width: "270px", targets: [6] },
          { width: "150px",orderable: false, targets: [3] },
          {
            render: function ( data, type, row ) {
                    return "Rp "+numeral(data).format();
                },
                targets: 3
          }
        ],
        fnDrawCallback: function (oSettings) {

              $("[data-toggle='confirmation']").confirmation({
                singleton: true,
                onConfirm:function(){
                  var myElement = $(this).closest('.popover').prev();
                  var id        = myElement.context.getAttribute('data-id');

                  $.ajax({
                      url: '{{url("Order")}}/'+id,
                      type: 'DELETE',
                      data: {_token: '{{csrf_token()}}'},
                      success: function(result) {
                        table.ajax.reload();

                        toastr.success("Order Berhasil dihapus", "Success");

                        toastr.options = {
                          "closeButton": false,
                          "debug": false,
                          "newestOnTop": false,
                          "progressBar": false,
                          "positionClass": "toast-top-right",
                          "preventDuplicates": false,
                          "onclick": null,
                          "showDuration": "300",
                          "hideDuration": "1000",
                          "timeOut": "5000",
                          "extendedTimeOut": "1000",
                          "showEasing": "swing",
                          "hideEasing": "linear",
                          "showMethod": "fadeIn",
                          "hideMethod": "fadeOut"
                        }
                      }
                  });

                }
              });
            }
    });
});


</script>
<script src="//cdnjs.cloudflare.com/ajax/libs/numeral.js/2.0.6/numeral.min.js"></script>
<script src="{{asset("assets/global/plugins/bootstrap-confirmation/bootstrap-confirmation.min.js")}}" type="text/javascript"></script>
<script src="{{asset("assets/pages/scripts/ui-confirmations.min.js")}}" type="text/javascript"></script>

@endpush

optic-distribution-system2/resources/views/sales/view.blade.php
@extends('layouts.app')

@component('components.select2Plugin')
@endcomponent

@section('content')

<div class="page-content-wrapper">
  <div class="page-content-wrapper">
      <div class="page-content">
          <div class="page-bar">
              <ul class="page-breadcrumb">
                  <li>
                      <i class="icon-home"></i>
                      <a href="{{ url("Order") }}">Manage Order</a>
                      <i class="fa fa-angle-right"></i>
                  </li>
                  <li>
                      <span>Detail Order</span>
                  </li>
              </ul>
          </div>
          <!-- BODY CONTENT -->
          <div class="portlet light bordered">
              <div class="portlet-title">
                  <div class="caption">
                      <i class="icon-equalizer font-red-sunglo"></i>
                      <span class="caption-subject font-red-sunglo bold uppercase">Order</span>
                      <span class="caption-helper">Detail invoice</span>
                  </div>
                  <div class="tools">
                      <a href="" class="collapse"> </a>
                      <a href="#portlet-config" data-toggle="modal" class="config"> </a>
                      <a href="" class="reload"> </a>
                      <a href="" class="remove"> </a>
                  </div>
              </div>
              <div class="portlet-body form">
                  <!-- BEGIN FORM-->
                    <form id="order">
                      <div class="form-body" style="padding-top:0px">
                          <h3 class="form-section">Invoice Information</h3>
                          <div class="row">
                              <div class="col-md-6">
                                  <div class="form-group">
                                      <label class="control-label col-md-3">Nama pegawai</label>
                                      <div class="col-md-9">
                                          <input type="text" class="form-control" value="{{$sale->staff_name->username}}" readonly>
                                      </div>
                                  </div>
                              </div>
                              <!--/span-->
                              <div class="col-md-6">
                                  <div class="form-group">
                                      <label class="control-label col-md-3">Tanggal Invoice</label>
                                      <div class="col-md-9">
                                          <input type="text" class="form-control" value="{{$sale->created_at}}" readonly>
                                      </div>
                                  </div>
                              </div>
                              <!--/span-->
                          </div>
                          <!--/row-->

                          <!--/row-->
                          <div class="row" style = "margin-top:10px">
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label class="control-label col-md-3">Cabang</label>
                                    <div class="col-md-9">
                                        <input type="text" class="form-control" value="{{$sale->staff_name->cabang->nama}}" readonly> </div>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label class="control-label col-md-3">INVOICE ID</label>
                                    <div class="col-md-9">
                                        <input type="text" class="form-control" value="{{$sale->id_string}}" readonly> </div>
                                </div>
                            </div>
                          </div>
                          <h3 class="form-section">Receiver Information</h3>
                          <!--/row-->
                          <div class="row">
                              <div class="col-md-6">
                                  <div class="form-group">
                                      <label class="control-label col-md-3">Optic</label>
                                      <div class="col-md-9">
                                        <input type="text" class="form-control" value="{{$sale->optic->nama}}" readonly>
                                      </div>
                                  </div>
                              </div>
                              <div class="col-md-6">
                                  <div class="form-group">
                                      <label class="control-label col-md-3">Pembayaran</label>
                                      <div class="col-md-9">
                                        <input type="text" class="form-control" value="{{$sale->jenis_string}}" readonly>
                                      </div>
                                  </div>
                              </div>
                          </div>

                          <div class="row" style="margin-top:10px">
                              <div class="col-md-6">
                                  <div class="form-group">
                                      <label class="control-label col-md-3">Alamat Optic</label>
                                      <div class="col-md-9">
                                          <input type="text" class="form-control" value="{{$sale->optic->alamat}}" readonly>
                                      </div>
                                  </div>
                              </div>
                              <div class="col-md-6">
                                  <div class="form-group">
                                      <label class="control-label col-md-3">Batas Tempo</label>
                                      <div class="col-md-9">
                                          <input type="text" class="form-control" value="{{$sale->jatuh_tempo}}" readonly>
                                      </div>
                                  </div>
                              </div>
                          </div>

                          <h3 class="form-section">Item</h3>
                          <div class="row table-scrollable">
                            <table class="table table-hover" id="itemSales">
                                <thead>
                                    <tr>
                                        <th> Categeory </th>
                                        <th> Sub Category </th>
                                        <th> Produk </th>
                                        <th> Pcs </th>
                                        <th> Unit Price </th>
                                        <th> Discount </th>
                                        <th> Amount </th>
                                    </tr>
                                </thead>
                                <tbody>
                                  @foreach ($items as $item)

                                  <?php
                                    $diskon = $item->pivot->jumlah * $item->pivot->harga_jual * $item->pivot->diskon / 100;
                                    $total  = $item->pivot->jumlah * $item->pivot->harga_jual;
                                    $total  = $total - $diskon;
                                  ?>
                                  <tr>
                                    <td>{{$item->subCategory->category->nama}}</td>
                                    <td>{{$item->subCategory->nama}}</td>
                                    <td>{{$item->nama}}</td>
                                    <td>{{$item->pivot->jumlah}}</td>
                                    <td class="textRight">{{number_format($item->pivot->harga_jual,0)}}</td>
                                    <td class="textRight">{{$item->pivot->diskon}}%
                                    <br>
                                      {{number_format($diskon,0)}}
                                    </td>


                                    <td class="textRight">{{number_format($total,0)}}</td>
                                  </tr>
                                  @endforeach
                                </tbody>
                            </table>
                          </div>
                          <div class="row">
                            <div class="col-md-8">
                                <h3 class="form-section">Keterangan</h3>
                                <textarea class="form-control" placeholer="Message" id="keterangan" name="keterangan" value="{{$sale->jatuh_tempo}}" readonly></textarea>
                            </div>
                            <div class="col-md-4">
                                <h3 class="form-section">Total</h3>
                                <h4 id="totalAmount">Rp {{$sale->total}}</h4>
                            </div>
                          </div>

                          <!--/row-->
                      </div>
                    </form>

                      <div class="form-actions right">
                          <a href="{{ url("Print") }}/{{$sale->id}}"><button type="submit" class="btn blue">
                              <i class="fa fa-check"></i> Print Invoice</button></a>
                      </div>
                  <!-- END FORM-->
              </div>
          </div>
          <!-- END BODY CONTENT -->

      </div>
      <!-- END CONTENT -->
  </div>
</div>

@push('scripts')
  <script src="//cdnjs.cloudflare.com/ajax/libs/numeral.js/2.0.6/numeral.min.js"></script>
@endpush

@endsection